IDC_TEXTLINENR		EQU 1
IDC_EXTENDSELECTION	EQU 2
IDC_GO				EQU 3
IDC_OK				EQU 4

.CODE

GoToLineDialogProc Proc hDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
Local chrg		:CHARRANGE

	.If uMsg==WM_INITDIALOG
	.ElseIf uMsg == WM_COMMAND
		MOV EAX,wParam
		SHR EAX,16
		.If AX==BN_CLICKED
			MOV EAX,wParam
			.If AX == IDC_OK
				Invoke SendMessage,hDlg,WM_CLOSE,0,0
				
			.ElseIf AX == IDC_GO
				Invoke GetDlgItemInt,hDlg,IDC_TEXTLINENR,NULL,FALSE
				.If EAX
					DEC EAX
				.EndIf
				PUSH EAX	;LineNo (Zero based)
				Invoke SendMessage,hEdit,EM_GETLINECOUNT,0,0
				POP EDX
				
				.If EDX >= EAX
					MOV EDX,EAX
					DEC EDX
				.EndIf
				
				Invoke SendMessage,hEdit,EM_LINEINDEX,EDX,0
				MOV chrg.cpMin,EAX
				
				
				Invoke SendMessage,hEdit,EM_LINELENGTH,EAX,0
				ADD EAX,chrg.cpMin
				MOV chrg.cpMax,EAX
				
				;Extend Selection?
				Invoke IsDlgButtonChecked,hDlg,IDC_EXTENDSELECTION
				.If EAX
					;Get current selection
					PUSH chrg.cpMin
					PUSH chrg.cpMax
					Invoke SendMessage,hEdit,EM_EXGETSEL,0,ADDR chrg
					POP EAX	;End Of line to select
					POP ECX	;Start of line to select
					.If ECX<chrg.cpMin
						MOV chrg.cpMin,ECX
					.EndIf
					.If EAX>chrg.cpMax
						MOV chrg.cpMax,EAX
					.EndIf
				.EndIf
				
				Invoke SendMessage,hEdit,EM_EXSETSEL,0,ADDR chrg
				Invoke SendMessage,hEdit,EM_SCROLLCARET,0,0
				
			.ElseIf AX == IDC_EXTENDSELECTION
				;Extend Selection check box--->Do nothing!
			.Else
				Invoke SendMessage,hDlg,WM_CLOSE,0,0
			.EndIf
		.EndIf
	.ElseIf uMsg==WM_CLOSE
		Invoke DestroyWindow,hDlg
		
	.ElseIf uMsg==WM_ACTIVATE
		.If wParam==WA_ACTIVE || wParam==WA_CLICKACTIVE
			MOV EAX,hDlg
			MOV hModeless,EAX
		.ElseIf wParam==WA_INACTIVE
			MOV hModeless,0
		.EndIf
		
	.Else
		MOV EAX, FALSE
		RET
	.EndIf
	MOV EAX,TRUE
	RET
GoToLineDialogProc EndP
