Include		Includes.inc
Include		..\HiEdit.inc
IncludeLib	..\HiEdit.lib

WinMain 			PROTO	:DWORD,	:DWORD,	:DWORD,	:DWORD
DlgProc 			PROTO	:HWND,	:DWORD,	:DWORD,	:DWORD
AboutDialogProc 	PROTO	:HWND,	:DWORD,	:DWORD,	:DWORD
BinToDecimal					PROTO	:DWORD,	:LPSTR

ENM_SCROLLEVENTS				EQU 8h

IDM_MENU						EQU 100
IDM_NEW							EQU 101
IDM_OPEN						EQU 102
IDM_SAVE						EQU 103
IDM_SAVEAS						EQU 104
IDM_SEPARATOR1					EQU 105
IDM_PRINT						EQU 108
IDM_SEPARATOR2					EQU 109
IDM_EXIT						EQU 110

IDM_UNDO						EQU 201
IDM_REDO						EQU 202
IDM_SEPARATOR3					EQU 203
IDM_CUT							EQU 204
IDM_COPY						EQU 205
IDM_PASTE						EQU 206
IDM_DELETE						EQU 207
IDM_SEPARATOR4					EQU 208
IDM_FIND						EQU 209
IDM_FINDNEXT					EQU 210
IDM_FINDPREVIOUS				EQU 211
IDM_REPLACE						EQU 212
IDM_GOTOLINE					EQU 213
IDM_SEPARATOR5					EQU 214
IDM_SELECTALL					EQU 215

IDM_WM_SETTEXT					EQU 301
IDM_WM_GETTEXT					EQU 302
IDM_WM_GETTEXTLENGTH			EQU 303
IDM_WM_SETFONT					EQU 304
IDM_EM_GETSEL					EQU 305
IDM_EM_SETSEL					EQU 306
IDM_EM_SCROLL					EQU 307
IDM_EM_LINESCROLL				EQU 308
IDM_EM_SCROLLCARET				EQU 309
IDM_EM_GETMODIFY				EQU 310
IDM_EM_SETMODIFY				EQU 311
IDM_EM_GETLINECOUNT				EQU 312
IDM_EM_LINEINDEX				EQU 313
IDM_EM_GETTHUMB					EQU 314
IDM_EM_LINELENGTH				EQU 315
IDM_EM_REPLACESEL				EQU 316
IDM_EM_CANUNDO					EQU 317
IDM_EM_UNDO						EQU 318
IDM_EM_LINEFROMCHAR				EQU 319
IDM_EM_EMPTYUNDOBUFFER			EQU 320
IDM_EM_GETFIRSTVISIBLELINE		EQU 321
IDM_EM_GETLINE					EQU 322
IDM_EM_POSFROMCHAR				EQU 323
IDM_EM_CHARFROMPOS				EQU 324
IDM_WM_CUT						EQU 325
IDM_WM_COPY						EQU 326
IDM_WM_PASTE					EQU 327
IDM_WM_CLEAR					EQU 328
IDM_WM_UNDO						EQU 329
IDM_HEM_CLEARFILE				EQU 330
IDM_HEM_OPENFILE				EQU 331
IDM_HEM_SAVEFILE				EQU 332
IDM_HEM_LINENUMBERSBAR			EQU 333
IDM_HEM_SETCOLORS				EQU 334
IDM_HEM_GETCOLORS				EQU 335
IDM_HEM_GETUNDODATA				EQU 336
IDM_HEM_GETREDODATA				EQU 337
IDM_HEM_SETTABWIDTH				EQU 338
IDM_HEM_AUTOINDENT				EQU 339
IDM_EM_CANPASTE					EQU 340
IDM_EM_EXGETSEL					EQU 341
IDM_EM_EXLINEFROMCHAR			EQU 342
IDM_EM_EXSETSEL					EQU 343
IDM_EM_FINDTEXT					EQU 344
IDM_EM_FORMATRANGE				EQU 345
IDM_EM_GETEVENTMASK				EQU 346
IDM_EM_GETSELTEXT				EQU 347
IDM_EM_SETEVENTMASK				EQU 348
IDM_EM_GETTEXTRANGE				EQU 349
IDM_EM_FINDTEXTEX				EQU 350
IDM_EM_REDO						EQU 351
IDM_EM_CANREDO					EQU 352
IDM_EM_GETUNDONAME				EQU 353
IDM_EM_GETREDONAME				EQU 354


IDM_ABOUT						EQU 401

IDM_VIEWTOOLBAR					EQU 501
IDM_VIEWSTATUSBAR				EQU 502

IDD_ABOUT						EQU 1000
IDD_FINDREPLACE					EQU 1002
IDD_GOTOLINE					EQU 1003

IDA_ACCEL						EQU 1

.CONST
tbMain	TBBUTTON <0, IDM_NEW, TBSTATE_ENABLED,TBSTYLE_BUTTON, 0, 0>
		TBBUTTON <1, IDM_OPEN, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
		TBBUTTON <2, IDM_SAVE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
		TBBUTTON <0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0>			
		TBBUTTON <3, IDM_PRINT, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
		TBBUTTON <0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0>		
		TBBUTTON <4, IDM_FIND, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
		TBBUTTON <0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0>
		TBBUTTON <5, IDM_CUT, 0, TBSTYLE_BUTTON, 0, 0>
		TBBUTTON <6, IDM_COPY, 0, TBSTYLE_BUTTON, 0, 0>
		TBBUTTON <7, IDM_PASTE, 0, TBSTYLE_BUTTON, 0, 0>
		TBBUTTON <0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0>
		TBBUTTON <8, IDM_UNDO, 0, TBSTYLE_BUTTON, 0, 0>
		TBBUTTON <9, IDM_REDO, 0, TBSTYLE_BUTTON, 0, 0>
		
.DATA
lfnt					LOGFONT <-12,0,0,0,400,FALSE,FALSE,FALSE,0,0,0,0,0,'Courier New'>
szControlClass			DB "HiEdit",0
;szControlDllName		DB "HiEdit.dll",0

szClassName				DB "HiEditor",0
szAppName				DB "HiEdit Demo",0
szMenuName				DB "FirstMenu",0
szAllFiles				DB "All Files (*.*)",0,"*.*",0,0
szSaveFileProblem		DB "File Saving Problem",0
szOpenFileProblem		DB "File Opening Problem",0
szToolbarClass			DB "ToolbarWindow32",0
szStatusBarClass		DB "msctls_statusbar32",0
szLnColSel				DB "Ln %lu    Col %lu    Sel %lu"
szNULL					DB 0

.DATA?
hMain					DWORD	?
szFileName				DB MAX_PATH+1 DUP	(?)
pd						PRINTDLG	<?>
Colors					HECOLORS	<?>
hInstance				HINSTANCE	 ?

bLineNumbers			DWORD	?
CommandLine				LPSTR	?
;hLib					DWORD	?
hEdit					DWORD	?
hFont					HFONT	?
hModeless				HWND	?
hImgListNormal			DWORD	?
hImgListDisabled		DWORD	?
hToolBar				DWORD	?
hStatusBar				DWORD	?
hNextViewer				DWORD	?

Include FindReplace.asm
Include GoToLine.asm
;Include UndoRedo.asm

.CODE
Start:
	Invoke InitCommonControls
	Invoke GetModuleHandle, NULL
	MOV hInstance,EAX
	Invoke GetCommandLine
	Invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	Invoke ExitProcess,EAX

;GetMeasurementSystem Proc
;Local Buffer[4]:BYTE
;
;	Invoke GetLocaleInfo,LOCALE_USER_DEFAULT,LOCALE_IMEASURE,ADDR Buffer,SizeOf Buffer
;	MOV AL,Buffer
;	.If AL=='1'
;		MOV EAX,TRUE	;US System (inches)
;	.Else
;		XOR EAX,EAX		;metric system (millimiters)
;	.EndIf
;	RET
;
;GetMeasurementSystem endp

DisplayKeyState Proc Key:DWORD
Local Buffer[5]:BYTE

	.If Key==VK_INSERT
		Invoke SendMessage,hStatusBar,SB_GETTEXT,2,ADDR Buffer
		.If Buffer[0]==0
			MOV EDX,CTEXT("OVR")
		.Else
			MOV EDX,Offset szNULL
		.EndIf
		MOV ECX,2
		
	.ElseIf Key==VK_NUMLOCK
		Invoke GetKeyState,VK_NUMLOCK
		AND EAX,1
		.If EAX==1
			MOV EDX,CTEXT("NUM")
		.Else
			MOV EDX,Offset szNULL
		.EndIf
		MOV ECX,1
		
	.ElseIf Key==VK_CAPITAL
		Invoke GetKeyState,VK_CAPITAL
		AND EAX,1
		.If EAX==1
			MOV EDX,CTEXT("CAPS")
		.Else
			MOV EDX,Offset szNULL
		.EndIf
		XOR ECX,ECX
		
		
	.Else	;Do nothing
		RET
		
	.EndIf
	
	Invoke SendMessage,hStatusBar,SB_SETTEXT,ECX,EDX
	
	Ex:
	RET
DisplayKeyState EndP

OpenExistingFile Proc hWnd:HWND
Local ofn	:OPENFILENAME

	Invoke RtlZeroMemory,ADDR ofn,SizeOf OPENFILENAME
	;Setup the ofn struct
	MOV ofn.lStructSize,SizeOf OPENFILENAME
	PUSH hWnd
	POP ofn.hwndOwner
	PUSH hInstance
	POP ofn.hInstance
	MOV ofn.lpstrFilter,Offset szAllFiles
	MOV ofn.lpstrFile,Offset szFileName
	MOV ofn.nMaxFile,MAX_PATH
	MOV ofn.Flags,OFN_EXPLORER OR OFN_FILEMUSTEXIST OR OFN_HIDEREADONLY OR OFN_PATHMUSTEXIST 
	
	Invoke GetOpenFileName,ADDR ofn
	.If EAX
		Invoke UpdateWindow,hWnd
		Invoke GetCursor
		PUSH EAX
		Invoke LoadCursor,NULL,IDC_WAIT
		Invoke SetCursor,EAX
		
		Invoke SendMessage,hStatusBar,SB_SETTEXT,4,CTEXT("Opening file ...")
		Invoke SendMessage,hEdit,HEM_OPENFILE,0,Offset szFileName
		.If !EAX
			
			Invoke MessageBox,hWnd,offset szOpenFileProblem,Offset szAppName,MB_OK
			
		.EndIf
		Invoke SendMessage,hStatusBar,SB_SETTEXT,4,Offset szNULL
		POP EAX
		Invoke SetCursor,EAX
	.EndIf
	RET
OpenExistingFile EndP

SaveFileAs Proc  hWnd:HWND
Local ofn	:OPENFILENAME
	;Zero out the ofn struct
	Invoke RtlZeroMemory,ADDR ofn,SizeOf ofn
	;Setup the ofn struct
	MOV ofn.lStructSize,SizeOf ofn
	PUSH hWnd
	POP ofn.hwndOwner
	PUSH hInstance
	POP ofn.hInstance
	MOV ofn.lpstrFilter,Offset szAllFiles
	
	;Note that if buffer contains a file name, then its path is used as the Initial directory
	MOV ofn.lpstrFile, Offset szFileName
	MOV ofn.nMaxFile,MAX_PATH

	MOV ofn.Flags,OFN_EXPLORER OR OFN_HIDEREADONLY OR OFN_PATHMUSTEXIST OR OFN_OVERWRITEPROMPT
	Invoke GetSaveFileName,ADDR ofn
	RET
SaveFileAs EndP

SelectEditorFont Proc hWnd:HWND
Local cf:CHOOSEFONT

	Invoke RtlZeroMemory,ADDR cf,SizeOf cf
	MOV cf.lStructSize,SizeOf cf
	MOV EAX, hWnd
	MOV cf.hwndOwner,EAX
	MOV cf.lpLogFont,Offset lfnt
	MOV cf.Flags,CF_EFFECTS OR CF_INITTOLOGFONTSTRUCT or CF_SCREENFONTS
	
	MOV EAX,Colors.NormalTextColor
	MOV cf.rgbColors,EAX

	Invoke ChooseFont,ADDR cf
	.If EAX
		Invoke DeleteObject,hFont
		
		Invoke CreateFontIndirect,Offset lfnt
		MOV hFont,EAX
		Invoke SendMessage,hEdit,WM_SETFONT,EAX,TRUE
		
		;Optional!
		Invoke SendMessage,hEdit,HEM_GETCOLORS,0,ADDR Colors
		MOV EAX,cf.rgbColors
		MOV Colors.NormalTextColor,EAX
		Invoke SendMessage,hEdit,HEM_SETCOLORS,ADDR Colors,TRUE
	.EndIf

	RET
SelectEditorFont EndP

WinMain Proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
Local wc		:WNDCLASSEX
Local msg		:MSG
Local hAccel	:HACCEL
;Local hWnd		:HWND

	MOV wc.cbSize,SizeOf WNDCLASSEX
	MOV wc.style,0
	MOV wc.lpfnWndProc, Offset WndProc
	MOV wc.cbClsExtra,NULL
	MOV wc.cbWndExtra,NULL
	PUSH hInst
	POP wc.hInstance
	MOV wc.hbrBackground,NULL
	MOV wc.lpszMenuName,IDM_MENU
	MOV wc.lpszClassName,Offset szClassName
	Invoke LoadIcon,hInstance,2
	MOV wc.hIcon,EAX
	MOV wc.hIconSm,EAX
	Invoke LoadCursor,NULL,IDC_ARROW
	MOV wc.hCursor,EAX
	Invoke RegisterClassEx, ADDR wc
	
	;******************************************
	;Use the following if HiEdit.lib is used:
	Invoke InitHiEditControl,hInstance
	
	;OR the following if HiEdit.dll is used:
	;Invoke LoadLibrary,Offset szControlDllName
	;MOV hLib,EAX
	;******************************************	
	
	Invoke OleInitialize,NULL
	Invoke CreateWindowEx,NULL,Offset szClassName,Offset szAppName,WS_OVERLAPPEDWINDOW OR WS_CLIPCHILDREN,CW_USEDEFAULT,CW_USEDEFAULT,600,400,NULL,NULL,hInst,NULL
	MOV hMain,EAX
	Invoke ShowWindow,EAX,SW_SHOWNORMAL
	Invoke UpdateWindow,hMain
	
	Invoke LoadAccelerators,hInst,IDA_ACCEL
	MOV hAccel,EAX
	
	.While TRUE
		Invoke GetMessage, ADDR msg,NULL,0,0
		.Break .If (!EAX)
		Invoke IsDialogMessage,hModeless,ADDR msg
		.If !EAX
			Invoke TranslateAccelerator,hMain,hAccel,ADDR msg		;This translates accelerator messages for us
			.If !EAX
				Invoke TranslateMessage, ADDR msg
				Invoke DispatchMessage, ADDR msg
			.EndIf
		.EndIf
	.EndW
	;******************************************
	;Use the following if HiEdit.lib is used:
	Invoke TerminateHiEditControl,hInstance
	
	;OR the following if HiEdit.dll is used:
	;Invoke FreeLibrary,hLib
	;******************************************
	
	Invoke OleUninitialize

	MOV EAX,msg.wParam
	RET
WinMain EndP

;Returns FALSE if no action must be taken by the caller
AskToSave Proc hWnd:HWND

	Invoke SendMessage,hEdit,EM_GETMODIFY,0,0
	.If EAX
		Invoke MessageBox,hWnd,CTEXT("Do you want to save changes?"),Offset szAppName,MB_YESNOCANCEL
		.If EAX==IDCANCEL
			JMP ExFALSE
		.ElseIf EAX==IDNO
			JMP ExTRUE
		.Else
			.If szFileName[0]==0
				Invoke SaveFileAs,hWnd
				.If !EAX
					JMP Ex
				.EndIf
			.EndIf
			
			Invoke SendMessage,hEdit,HEM_SAVEFILE,0,Offset szFileName
			.If !EAX
				Invoke MessageBox,hWnd,offset szSaveFileProblem,Offset szAppName,MB_OK
				JMP ExFALSE
			.EndIf
		.EndIf

	.EndIf
	
	ExTRUE:
	MOV EAX,TRUE
	RET
	
	ExFALSE:
	XOR EAX,EAX
	
	Ex:
	RET
AskToSave EndP

PrintHook Proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	XOR EAX,EAX
	RET
PrintHook EndP

;VERY basic printing feature
;You can improve it and share it with us 
Print Proc Uses EDI ESI hWnd:HWND
Local fr		:FORMATRANGE 
Local docInfo	:DOCINFO
Local chrg		:CHARRANGE

	;Initialize the PRINTDLG structure.
	MOV pd.lStructSize,SizeOf pd
	MOV EAX,hWnd
	MOV pd.hwndOwner,EAX
	MOV EAX,hInstance
	MOV pd.hInstance,EAX
	MOV pd.lpfnPrintHook,Offset PrintHook
	
	MOV pd.nMinPage,1
	MOV pd.nMaxPage,-1
	MOV pd.nFromPage,-1
	MOV pd.nToPage,-1
	
	Invoke SendMessage,hEdit,EM_EXGETSEL,0,addr chrg
	MOV EAX,chrg.cpMin
	.If EAX!=chrg.cpMax
		MOV pd.Flags,PD_RETURNDC OR PD_SELECTION OR PD_ENABLEPRINTHOOK
	.Else
		MOV pd.Flags,PD_RETURNDC OR PD_NOSELECTION OR PD_ENABLEPRINTHOOK
	.EndIf

	Invoke PrintDlg, ADDR pd
	.If EAX 
		;Fill out the FORMATRANGE structure
		
		;Rendering to the same DC we are measuring. 
		Invoke RtlZeroMemory,ADDR fr, SizeOf FORMATRANGE
		MOV EAX,pd.hDC
		MOV fr.hdc,EAX
		MOV fr.hdcTarget,EAX	;Not used by HiEdit
		
		
		;Set up the page and 1" margins all around.
		XOR EAX,EAX
		MOV fr.rcPage.left,EAX
		MOV fr.rc.left,1440		;=fr.rcPage.left + 1440	(1440 TWIPS = 1 inch.)
		MOV fr.rcPage.top,EAX
		MOV fr.rc.top,1440		;=fr.rcPage.top + 1440	(1440 TWIPS = 1 inch.)
		
		;fr.rcPage.right=(nHorizRes/nLogPixelsX) * 1440
		Invoke GetDeviceCaps, pd.hDC, HORZRES
		MOV ECX,1440
		MUL ECX
		PUSH EAX
		Invoke GetDeviceCaps, pd.hDC, LOGPIXELSX
		MOV ECX,EAX
		POP EAX
		XOR EDX,EDX
		DIV ECX
		MOV fr.rcPage.right,EAX
		;fr.rc.right=fr.rcPage.right - 1440
		SUB EAX,1440
		MOV fr.rc.right,EAX
		
		;fr.rcPage.bottom=(nVertRes/nLogPixelsY) * 1440;
		Invoke GetDeviceCaps, pd.hDC, VERTRES
		MOV ECX,1440
		MUL ECX
		PUSH EAX
		Invoke GetDeviceCaps, pd.hDC, LOGPIXELSY
		MOV ECX,EAX
		POP EAX
		XOR EDX,EDX
		DIV ECX
		MOV fr.rcPage.bottom,EAX
		;fr.rc.bottom= fr.rcPage.bottom - 1440
		SUB EAX,1440
		MOV fr.rc.bottom,EAX
		
		
		;Default the range of text to print as the entire document. 
		MOV fr.chrg.cpMin,0
		MOV fr.chrg.cpMax,-1
		
		;Fill out the DOCINFO structure.
		MOV docInfo.cbSize, SizeOf DOCINFO 
		MOV docInfo.lpszDocName,Offset szAppName
		MOV docInfo.lpszOutput,0
		MOV docInfo.lpszDatatype,NULL
		MOV docInfo.fwType,NULL
		
		;Be sure that the printer DC is in text mode. 
		Invoke SetMapMode, pd.hDC, MM_TEXT 
		Invoke StartDoc, pd.hDC, ADDR docInfo 
		
		XOR EDI,EDI
		Invoke SendMessage, hEdit, WM_GETTEXTLENGTH, 0, 0
		MOV ESI,EAX
		.While EDI < ESI
			Invoke StartPage, pd.hDC 
			Invoke SendMessage, hEdit, EM_FORMATRANGE, TRUE,ADDR fr 
			MOV EDI,EAX
			Invoke EndPage, pd.hDC 
			MOV fr.chrg.cpMin,EDI
			MOV fr.chrg.cpMax,-1 
		.EndW
		
		;Reset the formatting of the control (Not really needed for HiEdit)
		Invoke SendMessage, hEdit, EM_FORMATRANGE,0,0
		
		;Finish the document. 
		Invoke EndDoc, pd.hDC 
		;Delete the printer DC. 
		Invoke DeleteDC, pd.hDC 
	.EndIf
	
	RET
Print EndP

WndProc Proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
Local Buffer[1024]	:BYTE
Local pt			:POINT
Local txtrng		:TEXTRANGE
Local chrg			:CHARRANGE
Local CharsetInfo	:CHARSETINFO
Local findtext		:FINDTEXT
Local findtextex	:FINDTEXTEX
Local Rect			:RECT
Local sbParts[6]	:DWORD
Local UndoData		:UNDODATA

	MOV EAX,uMsg
	.If EAX==WM_COMMAND
		MOV EAX,wParam
		
		.If AX ==IDM_NEW
			Invoke AskToSave,hWnd
			.If EAX
				Invoke SendMessage,hEdit,HEM_CLEARFILE,0,0
				MOV szFileName[0],0
				
;				Invoke SendMessage,hToolBar,TB_ENABLEBUTTON,IDM_UNDO,FALSE
;				Invoke SendMessage,hToolBar,TB_ENABLEBUTTON,IDM_REDO,FALSE
;				
;				Invoke SendMessage,hToolBar,TB_ENABLEBUTTON,IDM_CUT,FALSE
;				Invoke SendMessage,hToolBar,TB_ENABLEBUTTON,IDM_COPY,FALSE
				
			.EndIf
			
		.ElseIf AX ==IDM_OPEN
			Invoke AskToSave,hWnd
			.If EAX
				Invoke OpenExistingFile,hWnd
				Invoke SetFocus,hEdit
			.EndIf
			
		.ElseIf AX ==IDM_SAVE
			.If szFileName[0]==0
				Invoke SaveFileAs,hWnd
				.If !EAX
					JMP Ex
				.EndIf
			.EndIf
			Invoke SendMessage,hEdit,HEM_SAVEFILE,0,Offset szFileName
			.If !EAX
				Invoke MessageBox,hWnd,offset szSaveFileProblem,Offset szAppName,MB_OK
			.EndIf
			
		.ElseIf AX==IDM_SAVEAS
			Invoke SaveFileAs,hWnd
			.If EAX
				Invoke SendMessage,hEdit,HEM_SAVEFILE,0,Offset szFileName
				.If !EAX
					Invoke MessageBox,hWnd,offset szSaveFileProblem,Offset szAppName,MB_OK
				.EndIf
			.EndIf
			
		.ElseIf AX==IDM_PRINT
			Invoke Print, hWnd
			
		.ElseIf AX==IDM_EXIT
			Invoke SendMessage,hWnd,WM_CLOSE,0,0
			
		.ElseIf AX==IDM_FIND
			Invoke CreateDialogParam,hInstance,IDD_FINDREPLACE,hWnd,Offset FindReplaceDlgProc,FALSE
			
		.ElseIf AX==IDM_UNDO
			Invoke SendMessage,hEdit,EM_UNDO,0,0
			
		.ElseIf AX==IDM_REDO
			Invoke SendMessage,hEdit,EM_REDO,0,0
			
		.ElseIf AX==IDM_FINDNEXT
			PUSH frFlags	;Save find Flags
			;Set find direction to down
			OR frFlags,FR_DOWN
			Invoke Find,frFlags
			POP frFlags	;Restore find Flags
			
		.ElseIf AX==IDM_FINDPREVIOUS
			PUSH frFlags	;Save find Flags
			;Set find direction to up
			AND frFlags,-1 XOR FR_DOWN
			Invoke Find,frFlags
			POP frFlags	;Restore find Flags
			
		.ElseIf AX==IDM_REPLACE
			Invoke CreateDialogParam,hInstance,IDD_FINDREPLACE,hWnd,Offset FindReplaceDlgProc,TRUE
			
		.ElseIf AX==IDM_GOTOLINE
			Invoke CreateDialogParam, hInstance, IDD_GOTOLINE, hWnd, Offset GoToLineDialogProc, EAX
			
		.ElseIf AX==IDM_SELECTALL
			Invoke SendMessage,hEdit,EM_SETSEL,0,-1
			
		.ElseIf AX==IDM_WM_SETTEXT
			Invoke SendMessage,hEdit,WM_SETTEXT,0,Offset szClassName
			
		.ElseIf AX==IDM_WM_GETTEXT
			Invoke SendMessage,hEdit,WM_GETTEXT,1023,ADDR Buffer
			PrintString Buffer
			PrintDec EAX
			
		.ElseIf AX==IDM_WM_GETTEXTLENGTH
			Invoke SendMessage,hEdit,WM_GETTEXTLENGTH,0,0
			PrintDec EAX
			
		.ElseIf AX==IDM_WM_SETFONT
			Invoke SelectEditorFont,hWnd
			
		.ElseIf AX==IDM_EM_GETSEL
			Invoke SendMessage,hEdit,EM_GETSEL,0,0
			PrintHex EAX
			
		.ElseIf AX==IDM_EM_EXLINEFROMCHAR
			Invoke SendMessage,hEdit,EM_EXLINEFROMCHAR,0,-1
			PrintDec EAX
			
		.ElseIf AX==IDM_EM_SETSEL
			Invoke SendMessage,hEdit,EM_SETSEL,2,20
			
		.ElseIf AX==IDM_EM_SCROLL
			Invoke SendMessage,hEdit,EM_SCROLL,SB_PAGEDOWN,0
			PrintDec EAX
			
		.ElseIf AX==IDM_EM_LINESCROLL
			Invoke SendMessage,hEdit,EM_LINESCROLL,3,10
			PrintDec EAX
			
		.ElseIf AX==IDM_EM_SCROLLCARET
			Invoke SendMessage,hEdit,EM_SCROLLCARET,0,0
			
		.ElseIf AX==IDM_EM_GETMODIFY
			Invoke SendMessage,hEdit,EM_GETMODIFY,0,0
			PrintHex EAX
			
		.ElseIf AX==IDM_EM_SETMODIFY
			Invoke SendMessage,hEdit,EM_SETMODIFY,TRUE,0
			
		.ElseIf AX==IDM_EM_GETLINECOUNT
			Invoke SendMessage,hEdit,EM_GETLINECOUNT,0,0
			PrintDec EAX
			
		.ElseIf AX==IDM_EM_LINEINDEX
			Invoke SendMessage,hEdit,EM_LINEINDEX,-1,0
			PrintDec EAX
			Invoke SendMessage,hEdit,EM_LINEINDEX,2,0
			PrintDec EAX
			Invoke SendMessage,hEdit,EM_LINEINDEX,200,0
			PrintDec EAX
			
		.ElseIf AX==IDM_EM_GETTHUMB
			Invoke SendMessage,hEdit,EM_GETTHUMB,0,0
			PrintDec EAX
			
		.ElseIf AX==IDM_EM_LINELENGTH
			;wParam=Character position
			Invoke SendMessage,hEdit,EM_LINELENGTH,8,0
			PrintDec EAX
			
		.ElseIf AX==IDM_EM_REPLACESEL
			Invoke SendMessage,hEdit,EM_REPLACESEL,TRUE,Offset szClassName
			
		.ElseIf AX==IDM_EM_CANUNDO
			Invoke SendMessage,hEdit,EM_CANUNDO,0,0
			PrintDec EAX
			
		.ElseIf AX==IDM_EM_UNDO
			Invoke MessageBox,hWnd,CTEXT("Usage demonstrated in Edit-Undo"),Offset szAppName,MB_OK
			
		.ElseIf AX==IDM_EM_LINEFROMCHAR
			Invoke SendMessage,hEdit,EM_LINEFROMCHAR,-1,0
			PrintDec EAX
			
			
		.ElseIf AX==IDM_EM_EMPTYUNDOBUFFER
			Invoke SendMessage,hEdit,EM_EMPTYUNDOBUFFER,0,0
			Invoke SendMessage,hToolBar,TB_ENABLEBUTTON,IDM_UNDO,FALSE
			Invoke SendMessage,hToolBar,TB_ENABLEBUTTON,IDM_REDO,FALSE
			
		.ElseIf AX==IDM_EM_GETFIRSTVISIBLELINE
			Invoke SendMessage,hEdit,EM_GETFIRSTVISIBLELINE,0,0
			PrintDec EAX
			
		.ElseIf AX==IDM_EM_GETLINE
			LEA EDX,Buffer
			MOV WORD PTR [EDX],255
			;Let's try to get text of line 6 (zero based)
			Invoke SendMessage,hEdit,EM_GETLINE,6,ADDR Buffer
			MOV Buffer[EAX],0
			PrintDec EAX
			PrintString Buffer
			
		.ElseIf AX==IDM_EM_POSFROMCHAR
			Invoke SendMessage,hEdit,EM_POSFROMCHAR,ADDR pt,8
			PrintDec pt.y
			PrintDec pt.x
			
		.ElseIf AX==IDM_EM_CHARFROMPOS
			Invoke SendMessage,hEdit,EM_CHARFROMPOS,0,35h	;i.e y=0 and x=53
			PrintDec EAX
			
			
		.ElseIf AX==IDM_WM_CUT || AX==IDM_CUT
			Invoke SendMessage,hEdit,WM_CUT,0,0
			
		.ElseIf AX==IDM_WM_COPY || AX==IDM_COPY
			Invoke SendMessage,hEdit,WM_COPY,0,0
			
		.ElseIf AX==IDM_WM_PASTE || AX==IDM_PASTE
			Invoke SendMessage,hEdit,WM_PASTE,0,0
			
		.ElseIf AX==IDM_WM_CLEAR || AX==IDM_DELETE
			Invoke SendMessage,hEdit,WM_CLEAR,0,0
			
		.ElseIf AX==IDM_WM_UNDO
			Invoke MessageBox,hWnd,CTEXT("Usage demonstrated in Edit-Undo"),Offset szAppName,MB_OK
			
		.ElseIf AX==IDM_HEM_CLEARFILE
			Invoke MessageBox,hWnd,CTEXT("Usage demonstrated in File-New"),Offset szAppName,MB_OK
			
		.ElseIf AX==IDM_HEM_OPENFILE
			Invoke MessageBox,hWnd,CTEXT("Usage demonstrated in File-Open"),Offset szAppName,MB_OK
			
		.ElseIf AX==IDM_HEM_SAVEFILE
			Invoke MessageBox,hWnd,CTEXT("Usage demonstrated in File-Save and File-Save As"),Offset szAppName,MB_OK
			
		.ElseIf AX==IDM_HEM_LINENUMBERSBAR
			XOR bLineNumbers,1
			Invoke SendMessage,hEdit,HEM_LINENUMBERSBAR,bLineNumbers,40
			
		.ElseIf AX==IDM_HEM_SETCOLORS
			MOV Colors.EditorBkColor,0
			MOV Colors.NormalTextColor,0FFFFFFh
			MOV Colors.ActiveSelectionBkColor,0ffh
			MOV Colors.InactiveSelectionBkColor,0c0h
			MOV Colors.LineNumberColor,0c0c0c0h
			MOV Colors.SelBarBkColor,0ff0000h
			Invoke SendMessage,hEdit,HEM_SETCOLORS,ADDR Colors,TRUE
			
		.ElseIf AX==IDM_HEM_GETCOLORS
			Invoke SendMessage,hEdit,HEM_GETCOLORS,0,ADDR Colors
			PrintHex Colors.EditorBkColor
			PrintHex Colors.NormalTextColor
			PrintHex Colors.ActiveSelectionBkColor
			PrintHex Colors.InactiveSelectionBkColor
			PrintHex Colors.LineNumberColor
			PrintHex Colors.SelBarBkColor
			
			
		;UNDODATA STRUCT
		;	pszUndoText 	LPSTR ?	;Pointer to a null-terminated string that Receives the Undo text
		;	cchUndoTextMax	DWORD ?	;Size of the buffer pointed to by the pszUndoText member
		;UNDODATA ENDS
		.ElseIf AX==IDM_HEM_GETUNDODATA
			MOV Buffer[0],0
			LEA EDX,Buffer
			MOV UndoData.pszUndoText,EDX
			MOV UndoData.cchUndoTextMax,128
			Invoke SendMessage,hEdit,HEM_GETUNDODATA,1,ADDR UndoData
			MOV ECX,UndoData.pszUndoText
			PrintStringByAddr ECX
			PrintDec EAX	;EAX is type of Undo
			
		.ElseIf AX==IDM_HEM_GETREDODATA
			MOV Buffer[0],0
			;Invoke RtlZeroMemory,ADDR Buffer,128
			LEA EDX,Buffer
			MOV UndoData.pszUndoText,EDX
			MOV UndoData.cchUndoTextMax,128
			Invoke SendMessage,hEdit,HEM_GETREDODATA,1,ADDR UndoData
			MOV ECX,UndoData.pszUndoText
			PrintStringByAddr ECX
			PrintDec EAX	;EAX is type of Undo
			
		.ElseIf AX==IDM_HEM_SETTABWIDTH
			Invoke SendMessage,hEdit,HEM_SETTABWIDTH,8,TRUE
			
		.ElseIf AX==IDM_HEM_AUTOINDENT
			Invoke SendMessage,hEdit,HEM_AUTOINDENT,0,TRUE
			
		.ElseIf AX==IDM_EM_CANPASTE
			Invoke SendMessage,hEdit,EM_CANPASTE,CF_TEXT,0
			PrintHex EAX
			
		.ElseIf AX==IDM_EM_EXGETSEL
			Invoke SendMessage,hEdit,EM_EXGETSEL,0,ADDR chrg
			PrintDec chrg.cpMin
			PrintDec chrg.cpMax
			
		.ElseIf AX==IDM_EM_EXSETSEL
			MOV chrg.cpMin,1
			MOV chrg.cpMax,10
			Invoke SendMessage,hEdit,EM_EXSETSEL,0,ADDR chrg
			PrintDec EAX
			
		.ElseIf AX==IDM_EM_FINDTEXT
			Invoke MessageBox,hWnd,CTEXT("Usage demonstrated in the Find options of the Edit menu."),Offset szAppName,MB_OK
			
		.ElseIf AX==IDM_EM_FORMATRANGE
			Invoke MessageBox,hWnd,CTEXT("This message is supported but not demonstrated!"),Offset szAppName,MB_OK
			
		.ElseIf AX==IDM_EM_GETEVENTMASK
			Invoke SendMessage,hEdit,EM_GETEVENTMASK,0,0
			PrintHex EAX
			
		.ElseIf AX==IDM_EM_GETSELTEXT
			Invoke SendMessage,hEdit,EM_GETSELTEXT,0,ADDR Buffer
			PrintDec EAX
			PrintString Buffer
			
		.ElseIf AX==IDM_EM_SETEVENTMASK
			Invoke SendMessage,hEdit,EM_SETEVENTMASK,0,ENM_MOUSEEVENTS
			PrintHex EAX
			
		.ElseIf AX==IDM_EM_GETTEXTRANGE
			MOV txtrng.chrg.cpMin,3
			MOV txtrng.chrg.cpMax,8
			LEA EAX,Buffer
			MOV txtrng.lpstrText,EAX
			Invoke SendMessage,hEdit,EM_GETTEXTRANGE,0,ADDR txtrng
			PrintString Buffer
			PrintText "Characters copied="
			PrintDec EAX
			
		.ElseIf AX==IDM_EM_FINDTEXTEX
			Invoke MessageBox,hWnd,CTEXT("Usage demonstrated in the Find options of the Edit menu."),Offset szAppName,MB_OK
			
		.ElseIf AX==IDM_EM_REDO
			Invoke MessageBox,hWnd,CTEXT("Usage demonstrated in Edit-Redo."),Offset szAppName,MB_OK
			
		.ElseIf AX==IDM_EM_CANREDO
			Invoke SendMessage,hEdit,EM_CANREDO,0,0
			PrintDec EAX
			
		.ElseIf AX==IDM_EM_GETUNDONAME
			Invoke SendMessage,hEdit,EM_GETUNDONAME,0,0
			PrintDec EAX
			;UID_UNKNOWN	= 0	:The type of undo action is unknown.
			;UID_TYPING		= 1	:Typing operation.
			;UID_DELETE		= 2	:Delete operation.
			;UID_DRAGDROP	= 3	:Drag-and-drop operation.
			;UID_CUT		= 4	:Cut operation.
			;UID_PASTE		= 5	:Paste operation.
			;Extended Operations
			;UID_SETTEXT		EQU 6	;WM_SETTEXT message was used to set the control text
			;UID_REPLACESEL	EQU 7	;EM_REPLACESEL message was used to insert text
			;UID_CLEAR		EQU 8	;WM_CLEAR message was used to delete selected text
			
		.ElseIf AX==IDM_EM_GETREDONAME
			Invoke SendMessage,hEdit,EM_GETREDONAME,0,0
			PrintDec EAX
			;UID_UNKNOWN	= 0	:The type of undo action is unknown.
			;UID_TYPING		= 1	:Typing operation.
			;UID_DELETE		= 2	:Delete operation.
			;UID_DRAGDROP	= 3	:Drag-and-drop operation.
			;UID_CUT		= 4	:Cut operation.
			;UID_PASTE		= 5	:Paste operation.
			;Extended Operations
			;UID_SETTEXT		EQU 6	;WM_SETTEXT message was used to set the control text
			;UID_REPLACESEL	EQU 7	;EM_REPLACESEL message was used to insert text
			;UID_CLEAR		EQU 8	;WM_CLEAR message was used to delete selected text
			
		.ElseIf AX==IDM_ABOUT
			Invoke DialogBoxParam,hInstance,IDD_ABOUT,hWnd,Offset AboutDialogProc,NULL
			
		.ElseIf AX==IDM_VIEWTOOLBAR
			Invoke IsWindowVisible,hToolBar
			.If EAX
				MOV ECX,SW_HIDE
			.Else
				MOV ECX,SW_SHOW
			.EndIf
			Invoke ShowWindow,hToolBar,ECX
			Invoke SendMessage,hWnd,WM_SIZE,0,0
			
		.ElseIf AX==IDM_VIEWSTATUSBAR
			Invoke IsWindowVisible,hStatusBar
			.If EAX
				MOV ECX,SW_HIDE
			.Else
				MOV ECX,SW_SHOW
			.EndIf
			Invoke ShowWindow,hStatusBar,ECX
			Invoke SendMessage,hWnd,WM_SIZE,0,0
			
		.EndIf
		
		
	.ElseIf EAX==WM_SIZE
		
		Invoke IsWindowVisible,hStatusBar
		.If EAX
			Invoke MoveWindow, hStatusBar,0, 0, 0, 0,TRUE
			Invoke GetWindowRect, hStatusBar, ADDR Rect
			MOV EAX,Rect.bottom
			SUB EAX,Rect.top	;Height of Statusbar
		.Else
			XOR EAX,EAX
		.EndIf
		PUSH EAX
		Invoke GetClientRect,hWnd,ADDR Rect
		POP EAX
		SUB Rect.bottom,EAX
		
		Invoke IsWindowVisible,hToolBar
		.If EAX
			Invoke MoveWindow,hToolBar,0,0,Rect.right,25,TRUE
			SUB Rect.bottom,25
			ADD Rect.top,25
		.EndIf
		
		Invoke MoveWindow,hEdit,0,Rect.top,Rect.right,Rect.bottom,TRUE
		
	.ElseIf EAX==WM_SETFOCUS
		Invoke SetFocus,hEdit
		
	.ElseIf EAX==WM_CONTEXTMENU
		Invoke GetMenu,hWnd
		Invoke GetSubMenu,EAX,1
		
		MOV EDX,lParam
		MOV ECX,EDX
		AND EDX,0FFFFh	;xPos
		SHR ECX,16		;yPos
		
		Invoke TrackPopupMenu,EAX,TPM_LEFTALIGN or TPM_RIGHTBUTTON, EDX,ECX,0,hWnd,NULL
		
	.ElseIf EAX==WM_INITMENUPOPUP
		PUSH EDI
		PUSH EBX
		Invoke GetMenu,hWnd
		MOV EBX,EAX
		Invoke GetSubMenu,EAX,1
		.If EAX==wParam	;this is the edit submenu (or the context menu)
			MOV EDI,EAX
			Invoke SendMessage,hEdit,EM_EXGETSEL,0,ADDR chrg
			MOV EAX,chrg.cpMin
			MOV EBX,MF_BYCOMMAND
			.If EAX==chrg.cpMax
				OR EBX,MF_GRAYED
			.EndIf
			Invoke EnableMenuItem,EDI,IDM_CUT,EBX
			Invoke EnableMenuItem,EDI,IDM_COPY,EBX
			Invoke EnableMenuItem,EDI,IDM_DELETE,EBX
			
			
			Invoke SendMessage,hEdit,EM_CANPASTE,CF_TEXT,0
			MOV EBX,MF_BYCOMMAND
			.If !EAX
				OR EBX,MF_GRAYED
			.EndIf
			Invoke EnableMenuItem,EDI,IDM_PASTE,EBX
			
			MOV AL,FindBuffer
			MOV EBX,MF_BYCOMMAND
			.If !AL
				OR EBX,MF_GRAYED
			.EndIf
			Invoke EnableMenuItem,EDI,IDM_FINDNEXT,EBX
			Invoke EnableMenuItem,EDI,IDM_FINDPREVIOUS,EBX
			
			Invoke SendMessage,hEdit,EM_CANUNDO,0,0
			MOV EBX,MF_BYCOMMAND
			.If !EAX
				OR EBX,MF_GRAYED
			.EndIf
			Invoke EnableMenuItem,EDI,IDM_UNDO,EBX
			
			Invoke SendMessage,hEdit,EM_CANREDO,0,0
			MOV EBX,MF_BYCOMMAND
			.If !EAX
				OR EBX,MF_GRAYED
			.EndIf
			Invoke EnableMenuItem,EDI,IDM_REDO,EBX
		.Else
			Invoke GetSubMenu,EBX,3
			.If EAX==wParam	;this is the View submenu (or the context menu)
				Invoke IsWindowVisible,hToolBar
				MOV ECX,MF_BYCOMMAND
				.If EAX
					OR ECX,MF_CHECKED
				;.Else
				;	OR ECX,MF_UNCHECKED
				.EndIf
				Invoke CheckMenuItem,wParam,IDM_VIEWTOOLBAR,ECX
				
				Invoke IsWindowVisible,hStatusBar
				MOV ECX,MF_BYCOMMAND
				.If EAX
					OR ECX,MF_CHECKED
				;.Else
				;	OR ECX,MF_UNCHECKED
				.EndIf
				Invoke CheckMenuItem,wParam,IDM_VIEWSTATUSBAR,ECX
			.EndIf
		.EndIf
		POP EBX
		POP EDI
		
	.ElseIf EAX == WM_NOTIFY
		PUSH EBX
		MOV EBX, lParam
		.If [EBX].NMHDR.code==EN_SELCHANGE
			
			.If [EBX].HESELCHANGE.TextChanged
				
				;PrintText "CHANGED"
				
				Invoke SendMessage,hEdit,EM_CANUNDO,0,0
				Invoke SendMessage,hToolBar,TB_ENABLEBUTTON,IDM_UNDO,EAX
				Invoke SendMessage,hEdit,EM_CANREDO,0,0
				Invoke SendMessage,hToolBar,TB_ENABLEBUTTON,IDM_REDO,EAX
				
			;.Else
				
				;PrintText "NOT CHANGED"
				
			.EndIf
			
			MOV EAX,[EBX].HESELCHANGE.chrg.cpMin
			.If EAX!=[EBX].HESELCHANGE.chrg.cpMax
				MOV EAX,TRUE
			.Else
				XOR EAX,EAX
			.EndIf
			PUSH EAX
			Invoke SendMessage,hToolBar,TB_ENABLEBUTTON,IDM_CUT,EAX
			POP EAX
			Invoke SendMessage,hToolBar,TB_ENABLEBUTTON,IDM_COPY,EAX
			
			
			MOV EAX,[EBX].HESELCHANGE.chrg.cpMax
			SUB EAX,[EBX].HESELCHANGE.cpLine
			
			MOV ECX,[EBX].HESELCHANGE.chrg.cpMax
			MOV EDX,ECX
			
			SUB ECX,[EBX].HESELCHANGE.chrg.cpMin
			
			.If EDX<[EBX].HESELCHANGE.chrg.cpMin				
				NEG ECX
			.EndIf
			
			MOV EDX,[EBX].HESELCHANGE.LineNr
			INC EDX
			LEA EBX,Buffer
			;"Ln: %lu, Col: %lu, Sel: %lu"
			Invoke wsprintf,EBX,Offset szLnColSel,EDX, EAX,ECX
			
			Invoke SendMessage,hStatusBar,SB_SETTEXT,3,EBX
			
		.ElseIf [EBX].NMHDR.code==EN_MSGFILTER
			
			.If [EBX].MSGFILTER.msg==WM_KEYDOWN
				Invoke DisplayKeyState,[EBX].MSGFILTER.wParam
			.EndIf
			
			;For PhoBos
			.If [EBX].MSGFILTER.msg==WM_MOUSEWHEEL
				;PrintText "MouseWheel"
				Invoke GetKeyState,VK_CONTROL
				AND EAX,80h
				.If EAX
					MOV EAX,[EBX].MSGFILTER.wParam
					SHR EAX,16
					PUSH EAX
					.If SWORD PTR AX<0
						NEG AX
					.EndIf
					
					MOV ECX,WHEEL_DELTA
					XOR EDX,EDX
					DIV ECX
					
					POP ECX
					.If SWORD PTR CX>0
						NEG EAX
					.EndIf
					
					MOV ECX,lfnt.lfHeight
					ADD ECX,EAX
					.If SDWORD PTR ECX < 0 
						MOV lfnt.lfHeight,ECX
						Invoke DeleteObject,hFont
						Invoke CreateFontIndirect,Offset lfnt
						MOV hFont,EAX
						Invoke SendMessage,hEdit,WM_SETFONT,EAX,TRUE
					.EndIf
					
					;Do NOT process mousewheel any further
					MOV EAX,TRUE
					RET
					
				.EndIf
				
			.EndIf
			
			;Test:Works! (ENM_MOUSEEVENTS needed)
			;.If [EBX].MSGFILTER.msg>=WM_MOUSEFIRST && [EBX].MSGFILTER.msg<=WM_MOUSELAST
			;	;Uncomment to not allow processing of any mouse message
			;	POP EBX	;Balance the stack
			;	MOV EAX,TRUE
			;	RET
			;.EndIf
			
			
			
			
			;Test:Works!	For shoorick!
			;.If [EBX].MSGFILTER.msg==WM_CHAR && [EBX].MSGFILTER.wParam=="."
			;	MOV [EBX].MSGFILTER.wParam,","
			;.EndIf
			
			
			
			;Test:Works! (ENM_MOUSEEVENTS mask flag needed)
			.If [EBX].MSGFILTER.msg==WM_LBUTTONDOWN
				PrintText "Left Button Down"
			.ElseIf [EBX].MSGFILTER.msg==WM_LBUTTONUP
				PrintText "Left Button Up"
			.ElseIf [EBX].MSGFILTER.msg==WM_LBUTTONDBLCLK
				PrintText "Left Button Double Click"
				
			.ElseIf [EBX].MSGFILTER.msg==WM_RBUTTONDOWN
				PrintText "Right Button Down"
			.ElseIf [EBX].MSGFILTER.msg==WM_RBUTTONUP
				PrintText "Right Button Up"
				
				
			.ElseIf [EBX].MSGFILTER.msg==WM_MOUSEMOVE
				PrintText "Mouse Move"
			.EndIf
			
			;*******************************************************************
			;We want the control to process the event, so we return a zero value
			;********************************************************************
			
		.EndIf
		
		POP EBX
		
	.ElseIf EAX==WM_CLOSE
		Invoke AskToSave,hWnd
		.If EAX
			JMP DefWndProc
		.EndIf
		
	.ElseIf EAX==WM_DESTROY
		.If hFont
			Invoke DeleteObject,hFont
		.EndIf
		Invoke ImageList_Destroy,hImgListNormal
		Invoke ImageList_Destroy,hImgListDisabled
		Invoke ChangeClipboardChain,hWnd,hNextViewer
		
		Invoke PostQuitMessage,NULL
		
		
	;.ElseIf uMsg == WM_NCACTIVATE
	;	.If lParam
	;		Invoke SendMessage,hWnd,WM_NCACTIVATE,TRUE,0
	;		MOV EAX, TRUE
	;		RET
	;	.EndIf
		
	.ElseIf EAX==WM_CHANGECBCHAIN
		MOV EAX,wParam	;window being removed
		.If EAX!=hNextViewer
			Invoke SendMessage,hNextViewer,WM_CHANGECBCHAIN,wParam,lParam
		.Else
			MOV EAX,lParam
			MOV hNextViewer,EAX
		.EndIf
		
	.ElseIf EAX==WM_DRAWCLIPBOARD
		Invoke SendMessage,hEdit,EM_CANPASTE,CF_TEXT,0
		Invoke SendMessage,hToolBar,TB_ENABLEBUTTON,IDM_PASTE,EAX
		.If hNextViewer
			Invoke SendMessage,hNextViewer,WM_DRAWCLIPBOARD,0,0
		.EndIf
		
		
	.ElseIf EAX==WM_CREATE
		Invoke CreateWindowEx,NULL,Offset szStatusBarClass,NULL,WS_CHILD or WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,hWnd,NULL,hInstance,NULL
		MOV hStatusBar,EAX
		
		MOV [sbParts +  0],32
		MOV [sbParts +  4],64
		MOV [sbParts +  8],94
		MOV [sbParts +  12],254
		MOV [sbParts +  16],-1
		Invoke SendMessage,hStatusBar,SB_SETPARTS,5,ADDR sbParts
		
		Invoke CreateWindowEx,NULL,Offset szToolbarClass,NULL,WS_CHILD or WS_VISIBLE or TBSTYLE_FLAT or CCS_NORESIZE,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,hWnd,NULL,hInstance,NULL
		MOV hToolBar,EAX
		
		Invoke ImageList_LoadImage,hInstance,1000,16,14,0FF00FFh,IMAGE_BITMAP,LR_CREATEDIBSECTION
		MOV hImgListNormal,EAX
		Invoke ImageList_SetBkColor,hImgListNormal,CLR_NONE
		
		Invoke ImageList_LoadImage,hInstance,1001,16,14,0FF00FFh,IMAGE_BITMAP,LR_CREATEDIBSECTION
		MOV hImgListDisabled,EAX
		Invoke ImageList_SetBkColor,hImgListDisabled,CLR_NONE
		
		
		;Invoke SendMessage,hToolBar,TB_GETEXTENDEDSTYLE,0,0
		;OR EAX,TBSTYLE_EX_DRAWDDARROWS
		;Invoke SendMessage,hToolBar,TB_SETEXTENDEDSTYLE,0,EAX
		
		Invoke SendMessage,hToolBar,TB_BUTTONSTRUCTSIZE,SizeOf TBBUTTON,0
		Invoke SendMessage,hToolBar,TB_SETIMAGELIST,0,hImgListNormal
		Invoke SendMessage,hToolBar,TB_SETDISABLEDIMAGELIST,0,hImgListDisabled
		Invoke SendMessage,hToolBar,TB_ADDBUTTONS,14,ADDR tbMain
		
		Invoke CreateWindowEx,WS_EX_CLIENTEDGE,Offset szControlClass,Offset szAppName,WS_CLIPCHILDREN or WS_CHILD or WS_VISIBLE or WS_VSCROLL or WS_HSCROLL,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,hWnd,NULL,hInstance,NULL
		MOV hEdit,EAX
		
		Invoke SendMessage,hEdit,HEM_LINENUMBERSBAR,TRUE,30
		MOV bLineNumbers,TRUE
		
		;Dynamically choose the character set based on the current code page:
		Invoke GetACP
		PUSH TCI_SRCCODEPAGE
		LEA EDX,CharsetInfo
		PUSH EDX
		PUSH EAX
		CALL TranslateCharsetInfo
		MOV EAX,CharsetInfo.ciCharset
		MOV lfnt.lfCharSet,AL
		
		Invoke CreateFontIndirect,Offset lfnt
		MOV hFont,EAX
		Invoke SendMessage,hEdit,WM_SETFONT,EAX,TRUE
		
		Invoke SendMessage,hEdit,EM_SETEVENTMASK,0,ENM_KEYEVENTS OR ENM_SELCHANGE OR ENM_SCROLLEVENTS; OR ENM_MOUSEEVENTS
		
		;Invoke SendMessage,hEdit,EM_CANPASTE,CF_TEXT,0
		;Invoke SendMessage,hToolBar,TB_ENABLEBUTTON,IDM_PASTE,EAX
		
		Invoke SetClipboardViewer,hWnd
		MOV hNextViewer,EAX
		
		Invoke SetFocus,hEdit
		
	.ElseIf EAX == WM_NCACTIVATE
		.If lParam
			;Invoke SendMessage,hWnd,WM_NCACTIVATE,TRUE,0
			MOV EAX, TRUE
			RET
		.Else
			Invoke DefWindowProc,hWnd,uMsg,wParam,lParam
			RET
		.EndIf
		
	.ElseIf EAX==WM_ACTIVATEAPP
		Invoke DisplayKeyState,VK_CAPITAL
		Invoke DisplayKeyState,VK_NUMLOCK
		Invoke SendMessage,hWnd,WM_NCACTIVATE,wParam,0
		
	.Else
		DefWndProc:
		Invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		RET
	.EndIf
	
	ExFALSE:
	XOR EAX,EAX
	
	Ex:
	RET
WndProc EndP


End Start
