LEFTMARGIN		EQU 150
TOPMARGIN		EQU 150
RIGHTMARGIN		EQU	150
BOTTOMMARGIN	EQU 150

.CODE

PrintHook Proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	XOR EAX,EAX
	RET
PrintHook EndP

Print Proc hMain:HWND
;Local DocInfo			:DOCINFO
;Local lf				:LOGFONT
;Local hPrFont			:DWORD
;Local ptY				:DWORD
;Local nLine				:DWORD
;Local nMLine			:DWORD
;Local pt				:POINT
;Local tWt				:DWORD
;Local Rect				:RECT
;Local hRgn				:DWORD
Local chrg				:CHARRANGE
;Local nPageno			:DWORD
;Local Buffer[256]		:BYTE
Local pd				:PRINTDLG
;Local txtrng			:TEXTRANGE
;Local nPageSize			:DWORD		;Lines Per Page
;Local PrintBuffer[1024]	:BYTE
;
;Local nCopies			:WORD
;Local bCollate			:DWORD
Local FormatRange		:FORMATRANGE

	Invoke SendMessage,hEdit,EM_EXGETSEL,0,ADDR chrg

	Invoke RtlZeroMemory, ADDR pd, SizeOf pd
	MOV pd.lStructSize, SizeOf pd
	
	MOV pd.lpfnPrintHook,Offset PrintHook

	MOV EAX,hMain
	MOV pd.hwndOwner,EAX
	
	MOV EAX,hInstance
	MOV pd.hInstance,EAX

	MOV EAX,chrg.cpMin
	.If EAX!=chrg.cpMax
		MOV pd.Flags,PD_RETURNDC or PD_SELECTION or PD_ENABLEPRINTHOOK 
	.Else
		MOV pd.Flags,PD_RETURNDC or PD_NOSELECTION or PD_ENABLEPRINTHOOK 
	.EndIf

	MOV pd.nMinPage,1
	MOV pd.nMaxPage,-1
	MOV pd.nFromPage,-1
	MOV pd.nToPage,-1
	
	MOV pd.nCopies,1
	
	Invoke PrintDlg,ADDR pd

	.If EAX
		MOV EAX,pd.hDC
		MOV FormatRange.hdc,EAX
		MOV FormatRange.hdcTarget,EAX
		
		MOV FormatRange.rc.top,0
		MOV FormatRange.rc.bottom,400
		
		MOV FormatRange.rc.left,0;100
		MOV FormatRange.rc.right,4000
		
		MOV FormatRange.chrg.cpMin,0
		MOV FormatRange.chrg.cpMax,200
		Invoke SendMessage,hEdit,EM_FORMATRANGE,TRUE,ADDR FormatRange
		
;		MOV EAX,pd.Flags
;		AND EAX,PD_COLLATE
;		.If EAX==PD_COLLATE
;			;User selected collate option but printer driver does not support
;			;collation. Therefore Nr Of Copies will be retrieved from the
;			;PRINTDLG structure
;			;Collate = True
;			;Copies = pd.nCopies
;			;PrintText "Collate=TRUE"
;			;PrintDec pd.nCopies
;			MOV bCollate,TRUE
;			MOV AX,pd.nCopies
;			MOV nCopies,AX
;		.Else
;			;Print driver supports collation or collation not switched on.
;			;DEVMODE structure contains Collation and copy information.
;			;Get Copies and Collate settings from DEVMODE structure"
;			.If pd.hDevMode
;				Invoke GlobalLock,pd.hDevMode
;				XOR ECX,ECX
;				MOV CX,[EAX].DEVMODE.dmCollate
;				
;				;Collate
;				;PrintDec ECX
;				MOV bCollate,ECX
;				
;				
;				XOR ECX,ECX
;				MOV CX,[EAX].DEVMODE.dmCopies
;				;Copies = ECX
;				;Let's get the biggest value!
;				.If CX<pd.nCopies
;					MOV CX,pd.nCopies
;				.EndIf
;				
;				;Copies
;				MOV nCopies,CX
;				
;				Invoke GlobalUnlock,pd.hDevMode
;			.EndIf
;			
;		.EndIf
;		
;		
;		
;		Invoke RtlZeroMemory,ADDR lf,SizeOf lf
;		Invoke lstrcpy,ADDR lf.lfFaceName,ADDR lfnt.lfFaceName
;		
;		
;		Invoke GetDeviceCaps,pd.hDC,LOGPIXELSY   ;Returns pixels per inch in EAX
;		MOV ECX,lfnt.lfHeight
;		NEG ECX
;		MUL ECX
;		XOR EDX,EDX
;		MOV ECX,72
;		DIV ECX
;		;Now in EAX we have the line height in pixels for the printer
;		MOV lf.lfHeight,EAX
;		
;		
;		
;		MOV Rect.left,LEFTMARGIN
;		MOV Rect.top,TOPMARGIN
;		
;		Invoke GetDeviceCaps,pd.hDC,PHYSICALWIDTH
;		;The width of the physical page, in device units
;		SUB EAX,RIGHTMARGIN
;		MOV Rect.right,EAX
;		
;		Invoke GetDeviceCaps,pd.hDC,PHYSICALHEIGHT
;		;The height of the physical page, in device units
;		MOV Rect.bottom,EAX
;		SUB Rect.bottom,BOTTOMMARGIN
;		
;		
;		;Now Calculate Number Of Lines Per Page
;		XOR EDX,EDX
;		SUB EAX,TOPMARGIN
;		SUB EAX,BOTTOMMARGIN
;		MOV ECX,lf.lfHeight
;		DIV ECX
;		MOV nPageSize,EAX	;Number Of Lines Per Page
;		DEC nPageSize		;Subtract 1 line for the title "Page ?"
;		
;		
;		
;		MOV EAX,lfnt.lfWeight
;		MOV lf.lfWeight,EAX
;		Invoke CreateFontIndirect,ADDR lf
;		MOV hPrFont,EAX
;		
;		MOV DocInfo.cbSize,SizeOf DocInfo
;		MOV DocInfo.lpszDocName,Offset szAppName
;		
;		MOV EAX,pd.Flags
;		AND EAX,PD_PRINTTOFILE
;		.If EAX
;			MOV EAX,'ELIF'
;			MOV DWORD PTR Buffer,EAX
;			MOV EAX,':'
;			MOV DWORD PTR Buffer+4,EAX
;			LEA EAX,Buffer
;			MOV DocInfo.lpszOutput,EAX
;		.Else
;			MOV DocInfo.lpszOutput,NULL
;		.EndIf
;		
;		MOV DocInfo.lpszDatatype,NULL
;		MOV DocInfo.fwType,NULL
;		Invoke StartDoc,pd.hDC,ADDR DocInfo
;		
;		MOV EAX,pd.Flags
;		AND EAX,PD_SELECTION or PD_PAGENUMS	;=(1 or 2) i.e.=3
;		.If !EAX || EAX==PD_PAGENUMS	;all pages selected or 'Some Pages'
;			.If !EAX
;				MOV pd.nFromPage,1
;				MOV pd.nToPage,-1	;already there but let's be sure
;			.EndIf
;			MOVZX EAX,pd.nFromPage
;			DEC EAX
;			MOV nPageno,EAX
;			MOV EDX,nPageSize
;			MUL EDX
;			MOV nLine,EAX
;			Invoke SendMessage,hEdit,EM_GETLINECOUNT,0,0
;			OR EAX,EAX
;			JE Ex
;			INC EAX
;			MOV nMLine,EAX
;			
;		.Else;If EAX==PD_SELECTION	;"Selected Text"
;			Invoke SendMessage,hEdit,EM_EXLINEFROMCHAR,0,chrg.cpMin
;			MOV nLine,EAX
;			MOV ECX,nPageSize
;			XOR EDX,EDX
;			DIV ECX
;			MOV nPageno,EAX
;			Invoke SendMessage,hEdit,EM_EXLINEFROMCHAR,0,chrg.cpMax
;			SUB EAX,nLine
;			;INC EAX
;			ADD EAX,2
;			MOV nMLine,EAX
;			MOV pd.nToPage,-1	;already there but let's be sure
;		.EndIf
;		
;		
;		
;		Invoke CreateRectRgn,Rect.left,Rect.top,Rect.right,Rect.bottom
;		MOV hRgn,EAX
;		
;		Invoke SelectObject,pd.hDC,hPrFont
;		Invoke SelectObject,pd.hDC,hRgn
;		
;		
;		;Store nPageno,nMLine ???
;		
;		
;		
;		NxtPage:
;		;------
;		INC nPageno
;		MOV EAX,nPageno
;		
;		.If AX>pd.nToPage
;			JMP Ex
;		.EndIf
;		
;		SamePage:
;		;--------
;		MOV ptY,TOPMARGIN
;		Invoke StartPage,pd.hDC
;;		Invoke SelectObject,pd.hDC,hPrFont
;;		Invoke SelectObject,pd.hDC,hRgn
;		;Get tab width
;		MOV EAX,'WWWW'
;		MOV DWORD PTR Buffer,EAX
;		Invoke GetTextExtentPoint32,pd.hDC,ADDR Buffer,4,ADDR pt
;		MOV EAX,pt.x
;		SHR EAX,2
;		MOV ECX,4;TabSize
;		MUL ECX
;		MOV tWt,EAX
;		
;		;----------------------------------------------------------
;		MOV EAX,"egaP"
;		MOV DWORD PTR Buffer,EAX
;		MOV Buffer[4],' '
;		
;		Invoke wsprintf, ADDR Buffer[5], CTEXT("%lu"), nPageno
;		
;		Invoke lstrcpy,ADDR PrintBuffer,ADDR Buffer
;		
;		Invoke lstrlen,ADDR PrintBuffer
;		MOV ECX,EAX
;		PUSH EAX
;		Invoke GetTextExtentPoint32,pd.hDC,ADDR PrintBuffer,ECX,ADDR pt
;		;----------------------------------------------------------
;		POP ECX
;		
;		
;		;*************
;		;Invoke TabbedTextOut,pd.hDC,LEFTMARGIN,ptY,ADDR PrintBuffer,ECX,1,ADDR tWt,LEFTMARGIN
;		
;		
;		MOV EAX,pt.y
;		ADD ptY,EAX
;		SHR EAX,1
;		ADD ptY,EAX
;		
;		NxtLine:
;		;------
;		MOV EAX,ptY
;		ADD EAX,pt.y
;		ADD EAX,pt.y
;		CMP EAX,Rect.bottom
;		JNB Ep
;		DEC nMLine
;		JE Ep
;		Invoke SendMessage,hEdit,EM_LINEINDEX,nLine,0
;		MOV txtrng.chrg.cpMin,EAX
;		
;		Invoke SendMessage,hEdit,EM_LINELENGTH,EAX,0
;		 
;		ADD EAX,txtrng.chrg.cpMin
;		MOV txtrng.chrg.cpMax,EAX
;		INC nLine
;		LEA EAX,PrintBuffer
;		MOV txtrng.lpstrText, EAX
;		Invoke SendMessage,hEdit,EM_GETTEXTRANGE,0,ADDR txtrng
;		OR EAX,EAX
;		JE El
;		
;		Invoke lstrlen,ADDR PrintBuffer
;		MOV ECX,EAX
;		
;		;;*************
;		;Invoke TabbedTextOut,pd.hDC,LEFTMARGIN,ptY,ADDR PrintBuffer,ECX,1,ADDR tWt,LEFTMARGIN
;		
;		El:
;		;--
;		MOV EAX,pt.y
;		ADD ptY,EAX
;		JMP NxtLine
;		
;		Ep:
;		;--
;		Invoke EndPage,pd.hDC
;		.If nMLine
;			JMP NxtPage
;		.EndIf
;		
;		Ex:
;		;--
;		Invoke EndDoc,pd.hDC
;		Invoke DeleteDC,pd.hDC
;		Invoke DeleteObject,hPrFont
;		Invoke DeleteObject,hRgn
		
	.EndIf
	
	RET
Print EndP